﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.IO;

namespace Persistence {

  public class Root {

    [Storable]
    public int[] i = new int[] { 3, 4, 5, 6 };
    [Storable]
    public string s;
    [Storable]
    public ArrayList intArray = new ArrayList(new int[] { 1, 2, 3 });
    [Storable]
    public List<int> intList = new List<int>(new int[] { 321, 312, 321 });
    [Storable]
    public Custom c; 

  }

  public class Custom {
    [Storable]
    public int i;
    [Storable]
    public Root r;
    [Storable]
    public string name = "Serial";
  }

  public class NewSerializationTest {
    public static void Main() {
      Root r = new Root();
      r.c = new Custom();
      r.c.r = r;
      IPrimitiveSerializer[] serializers = {
          new String2XMLSerializer(),
          new Int2XMLSerializer()};
      Serializer s = new Serializer(r, serializers);
      Persistence.XmlFormatter xmlFormatter = new Persistence.XmlFormatter();
      StreamWriter writer = new StreamWriter("test.xml");
      foreach (ISerializationToken token in s) {
        string line = xmlFormatter.Format(token);
        writer.Write(line);
        Console.Out.Write(line);
      }
      writer.Close();
      XmlParser parser = new XmlParser(new StreamReader("test.xml"));
      DeSerializer deSerializer = new DeSerializer(
        new IPrimitiveSerializer[] { new Int2XMLSerializer(), new String2XMLSerializer() },
        new ICustomSerializer[] { new ArraySerializer(), new EnumerableSerializer() });
      object o = deSerializer.DeSerialize(parser);
      Console.Out.WriteLine(Util.AutoFormat(o, true));
      Console.In.ReadLine();
    }
  }
}
